#include <stdio.h>
#include <vector>
using namespace std;

int main()
{
    vector<int> brojeviKojiSuAnalizirani;
    int N, K;
    scanf("%d %d",&N,&K);
    int polje[N][N];
    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < N; j++)
        {
            scanf("%d",&polje[i][j]);
        }
    }

    for(int i = 0; i < N; i++)
    {
        int poslednjeI = i;
        for(int j = 0; j < N; j++)
        {
            int sorta = polje[i][j];
            int uLevo = 0;
            if(sorta != 0)
            {
                bool daLiJePravoUgaonik = true;
                while(polje[i][j+uLevo] == sorta)
                {
                    polje[i][j+uLevo] = 0;
                    uLevo++;
                }

                while(polje[++i][j] == sorta)
                {
                    int tempULevo = 0;
                    while(polje[i][j+tempULevo] == sorta)
                    {
                        polje[i][j+tempULevo] = 0;
                        tempULevo++;
                    }

                    daLiJePravoUgaonik = tempULevo == uLevo;

                    if(!daLiJePravoUgaonik)
                    {
                        brojeviKojiSuAnalizirani.push_back(-sorta);
                        break;
                    }
                }

                if(daLiJePravoUgaonik)
                {
                    bool dodaj = true;
                    for(int i = 0; i < brojeviKojiSuAnalizirani.size(); i++)
                    {
                        if(brojeviKojiSuAnalizirani[i] == sorta)
                        {
                            dodaj = false;
                            brojeviKojiSuAnalizirani[i]*= -1;
                        }
                        else if (brojeviKojiSuAnalizirani[i]*-1 == sorta)
                        {
                            dodaj = false;
                        }
                    }

                    if(dodaj)
                    {
                        brojeviKojiSuAnalizirani.push_back(sorta);
                    }
                }
            }

            if(uLevo > 0)
                j+= uLevo-1;
            i = poslednjeI;
        }
    }

    int br = 0;
    for(int i = 0; i < brojeviKojiSuAnalizirani.size(); i++)
        if(brojeviKojiSuAnalizirani[i] > 0)
            br++;

    printf("%d",br);

    return 0;
}